'use strict';
const Schema = require('mongoose').Schema;
const metaPlugin = require('naf-framework-mongoose-free/lib/model/meta-plugin');
const moneyPlugin = require('naf-framework-mongoose-free/lib/model/type-money-plugin');

// 教练费明细
const coachInBill = {
  lesson_id: { type: String, required: false, zh: '课程id' }, //
  type: { type: String, required: false, zh: '类型' }, // 0:公开课收入;1私教课收入;2提现
  school_id: { type: String, required: false, zh: '学校id', ref: 'School', getProp: [ 'name' ] }, //
  coach_id: { type: String, required: false, zh: '教练id', ref: 'Coach', getProp: [ 'name' ] }, //
};
const schema = new Schema(coachInBill, { toJSON: { getters: true, virtuals: true } });
schema.index({ id: 1 });
schema.index({ 'meta.createdAt': 1 });
schema.index({ school_id: 1 });
schema.index({ coach_id: 1 });

schema.plugin(metaPlugin);
schema.plugin(moneyPlugin({ zh: '金额' }));
module.exports = app => {
  const { mongoose } = app;
  return mongoose.model('CoachInBill', schema, 'coachInBill');
};
