'use strict';
const Schema = require('mongoose').Schema;
const metaPlugin = require('naf-framework-mongoose-free/lib/model/meta-plugin');
const moneyPlugin = require('naf-framework-mongoose-free/lib/model/type-money-plugin');

// 教练与学校的关系表
const relationCoachSchool = {
  coach_id: { type: String, required: true, zh: '教练id', ref: 'Coach', getProp: [ 'name', 'phone', 'level', 'icon' ] }, //
  school_id: { type: String, required: true, zh: '学校id', ref: 'School', getProp: [ 'name', 'phone' ] }, //
  doc: { type: Object, required: false, zh: '教练档案' }, //
};
const schema = new Schema(relationCoachSchool, { toJSON: { virtuals: true, getters: true } });
schema.index({ id: 1 });
schema.index({ 'meta.createdAt': 1 });
schema.index({ coach_id: 1 });
schema.index({ school_id: 1 });

schema.plugin(metaPlugin);
schema.plugin(moneyPlugin({ zh: '工资' }));
module.exports = app => {
  const { mongoose } = app;
  return mongoose.model('RelationCoachSchool', schema, 'relationCoachSchool');
};
